﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////
//===================================================
// Some functions I've borrowed and modified
// from John Walker's script.
//===================================================
/*
       JavaScript functions for the Fourmilab Calendar Converter

                  by John Walker  --  September, MIM
              http://www.fourmilab.ch/documents/calendar/

                This program is in the public domain.
*/
//==================================================

var CalBtn,CalBtnA;

var J0000 = 1721424.5;                // Julian date of Gregorian epoch: 0000-01-01
var J1970 = 2440587.5;                // Julian date at Unix epoch: 1970-01-01
var JMJD  = 2400000.5;                // Epoch of Modified Julian Date system

function buildcalendar(sJahr,sMonat, sOut)
{
	System.Gadget.Settings.write("aktvisCal", sJahr + "|" + sMonat);
	if (HideBG != false)
	{
		CalBtn = CalDayBtnT;
		CalBtnA= CalDayAktBtnT;
	}
	else
	{
		CalBtn = CalDayBtn;
		CalBtnA= CalDayAktBtn;
	}

	var ISLjahr, Tageszahl=1, Start, Stop, Monatskopf="", x="", calCols, r, c, z;
	var newCalendar = "";

	var jJahr,jMonat,jTag;
	var KWcell="";

	if ((DisplayKW == 0) || (DisplayKW == 1)) // ISO and USA
	{
		Start = holeStart(sJahr,sMonat);

		Stop = 31;
		if(sMonat==4 ||sMonat==6 || sMonat==9 || sMonat==11 ) --Stop;
		if(sMonat==2)
		{
			Stop = Stop - 3;
			x = leap_gregorian(sJahr);
			if(x) Stop++;
		}

		newCalendar += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		Monatskopf = clkMonth[sMonat] + " " + sJahr;
		newCalendar += SchreibeKopf(Monatskopf,"","");

		Tageszahl = 1;
		var KWrechnen = 1;
		calCols = new Array(8);

		for (r = 1; r <= 6; r++)
		{
			KWrechnen = 1;
			calCols = "";
			calCols = new Array(8);

			for (c = 0; c < calCols.length; c++)
			{
				if (System.Gadget.Settings.read("kwshowselect") != 0)
				{
					if (KWrechnen == 1)
					{
						if (Tageszahl <= Stop)
						{
							if (System.Gadget.Settings.read("kwshowselect") == 2)
							{
								KWcell = 7;
								if (DisplayKW == 0)
								{
									calCols[7] = KalenderWocheISO(sJahr,sMonat,Tageszahl);
								}
								else
								{
									calCols[7] = KalenderWocheUSA(sJahr,sMonat,Tageszahl);
								}
							}
							else if (System.Gadget.Settings.read("kwshowselect") == 1)
							{
								KWcell = 0;
								if (DisplayKW == 0)
								{
									calCols[0] = KalenderWocheISO(sJahr,sMonat,Tageszahl);
								}
								else
								{
									calCols[0] = KalenderWocheUSA(sJahr,sMonat,Tageszahl);
								}
							}
							else
							{
								calCols[0] = "";
							}
							KWrechnen = 0;
						}
					}
				}

				if (System.Gadget.Settings.read("kwshowselect") == 2)
				{
					if ((c < Start) && (r == 1))
					{
						if (c < 7) calCols[c] = 0;
					}
					else if (Tageszahl > Stop)
					{
						if (c < 7) calCols[c] = 0;
					}
					else
					{
						if (c < 7)
						{
							calCols[c] = Tageszahl;
							Tageszahl++;
						}
					}
				}
				else
				{
					if ((c < Start) && (r == 1))
					{
						if (c > 0) calCols[c] = 0;
					}
					else if (Tageszahl > Stop)
					{
						if (c > 0) calCols[c] = 0;
					}
					else
					{
						if (c > 0)
						{
							calCols[c] = Tageszahl;
							Tageszahl++;
						}
					}
				}
			}

			newCalendar += "<tr>";

			for (z = 0; z < calCols.length; z++)
			{
				if (z == KWcell)
				{
					newCalendar += erstelleZelle(z, calCols[z], sJahr, sMonat, Jahr, Monat, Tag, 1);
				}
				else
				{
					newCalendar += erstelleZelle(z, calCols[z], sJahr, sMonat, Jahr, Monat, Tag, "");
				}
			}

			newCalendar += "</tr>";
		}
	}
	else if (DisplayKW == 2) // Julian
	{
		KWcell = 0;
		var nowJD = GregToJul(Jahr,Monat,Tag,Stunden,Minuten,Sekunden);
		jJahr = nowJD[0];
		jMonat = nowJD[1];
		jTag = nowJD[2];

		var thismonthJD = GregToJul(sJahr,sMonat,Tag,Stunden,Minuten,Sekunden);
		var sjJahr = thismonthJD[0];
		var sjMonat = thismonthJD[1];
//		var sjTag = thismonthJD[2];
		var sjWeekday = thismonthJD[3];

		Start = holeStart(sjJahr,sjMonat);

		Stop = 31;
		if(sjMonat==4 || sjMonat==6 || sjMonat==9 || sjMonat==11 ) --Stop;
		if(sjMonat==2)
		{
			Stop = Stop - 3;
			x = leap_julian(sjJahr);
			if(x) Stop++;
		}

		newCalendar += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		Monatskopf = clkMonth[sjMonat] + " " + sjJahr;
		newCalendar += SchreibeKopf(Monatskopf,"","");

		Tageszahl = 1;
		calCols = new Array(8);

		for (r = 1; r <= 6; r++)
		{
			calCols = "";
			calCols = new Array(8);

			for (c = 0; c < calCols.length; c++)
			{
				calCols[0] = "";
				if ((c < Start) && (r == 1))
				{
					if (c > 0) calCols[c] = 0;
				}
				else if (Tageszahl > Stop)
				{
					if (c > 0) calCols[c] = 0;
				}
				else
				{
					if (c > 0)
					{
						calCols[c] = Tageszahl;
						Tageszahl++;
					}
				}
			}

			newCalendar += "<tr>";

			for (z = 0; z < calCols.length; z++)
			{
				if (z == KWcell)
				{
					newCalendar += erstelleZelle(z, calCols[z], sjJahr, sjMonat, jJahr, jMonat, jTag, 1);
				}
				else
				{
					newCalendar += erstelleZelle(z, calCols[z], sjJahr, sjMonat, jJahr, jMonat, jTag, "");
				}
			}

			newCalendar += "</tr>";
		}
	}
	else if (DisplayKW == 3) // Islamic
	{
		KWcell = 0;
		var nowISL = GregToIsl(Jahr,Monat,Tag,Stunden,Minuten,Sekunden);
		var iJahr = nowISL[0];
		var iMonat = nowISL[1];
		var iTag = nowISL[2];

		var thismonthISL = GregToIsl(sJahr,sMonat,Tag,Stunden,Minuten,Sekunden);
		var siJahr = thismonthISL[0];
		var siMonat = thismonthISL[1];
//		var siTag = thismonthISL[2];
		var siWeekday = thismonthISL[3];

		ISLjahr = siJahr;

		Start = holeStart(siJahr,siMonat);

		Stop = 30;
		if(siMonat==12)
		{
			Stop = Stop-1;
			x = leap_islamic(siJahr);
			if(x) Stop++;
		}

		newCalendar += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";

		Monatskopf = ISLmonth[siMonat];
		newCalendar += SchreibeKopf(Monatskopf,"","");

		Tageszahl = 1;
		calCols = new Array(8);

		for (r = 1; r <= 6; r++)
		{
			calCols = "";
			calCols = new Array(8);

			for (c = 0; c < calCols.length; c++)
			{
				calCols[0] = "";
				if ((c < Start) && (r == 1))
				{
					if (c > 0) calCols[c] = 0;
				}
				else if (Tageszahl > Stop)
				{
					if (c > 0) calCols[c] = 0;
				}
				else
				{
					if (c > 0)
					{
						calCols[c] = Tageszahl;
						Tageszahl++;
					}
				}
			}

			newCalendar += "<tr>";

			for (z = 0; z < calCols.length; z++)
			{
				if (z == KWcell)
				{
					newCalendar += erstelleZelle(z, calCols[z], siJahr, siMonat, iJahr, iMonat, iTag, 1);
				}
				else
				{
					newCalendar += erstelleZelle(z, calCols[z], siJahr, siMonat, iJahr, iMonat, iTag, "");
				}
			}

			newCalendar += "</tr>";
		}
	}

	if (DisplayKW == 3) // Islamic
	{
		newCalendar += "<tr><td colspan=\"6\" width=\"90\" height=\"10\">";
	}
	else
	{
		newCalendar += "<tr><td colspan=\"4\" width=\"65\" height=\"10\">";
	}

	newCalendar += "<div id=\"calstatus1\"";
	if (sOut == "gadget")
	{
		newCalendar += " onclick=\"showFlyout('cal')\"";
		newCalendar += " onMouseOver=\"showWMTT('d26')\" onMouseOut=\"hideWMTT()\"";
	}
	if ((DisplayKW == 0) || (DisplayKW == 1))
	{
		newCalendar += " class=\"fontsmall\">";
		var doy = Jetzt.getDOY();
		newCalendar += GadText[14] + ": " + doy;
	}
	else if (DisplayKW == 2) // Julian
	{
		newCalendar += " class=\"fontsmall\">";
		var JD = gregorian_to_jd(Jahr,Monat,Tag);
		newCalendar += "JD:" + JD;
	}
	else if (DisplayKW == 3) // Islamic
	{
		newCalendar += " class=\"fontsmall\">";
		var weekday = "yawm " + ISLAMIC_WEEKDAYS[WoTag];
		newCalendar += weekday;
	}
	newCalendar += "</div>";

	if (DisplayKW == 3) // Islamic
	{
		newCalendar += "</td><td colspan=\"2\" width=\"30\" height=\"10\">";
	}
	else
	{
		newCalendar += "</td><td colspan=\"4\" width=\"65\" height=\"10\">";
	}
	newCalendar += "<div id=\"calstatus2\" class=\"fontsmall\">";
	if ((DisplayKW == 0) || (DisplayKW == 1))
	{
		newCalendar += "&#160;";
	}
	else if (DisplayKW == 2) // Julian
	{
		newCalendar += "MJD:" + (JD - JMJD);
	}
	else if (DisplayKW == 3) // Islamic
	{
		newCalendar += ISLjahr;
	}
	newCalendar += "</div>";
	newCalendar += "</td></tr>";
	newCalendar += "</table>";

	this.calendar.innerHTML = newCalendar;

	if (DisplayKW == 3) // Islamic
	{
		calhead.style.fontSize = 10;
		calstatus1.style.fontSize = 10;
		calstatus2.style.fontSize = 11;
	}
}

function holeStart(sJahr,sMonat)
{
	var Zeit = new Date(sJahr,sMonat-1,1);
	var sStart = Zeit.getDay();

	if ((DisplayKW == 0) || (DisplayKW == 1))
	{
		if (System.Gadget.Settings.read("kwshowselect") == 2)
		{
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (sStart == 0)
				{
					sStart = 6;
				}
				sStart--;
			}
		}
		else
		{
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (sStart == 0)
				{
					sStart = 7;
				}
				sStart;
			}
			else
			{
				sStart++;
			}
		}
	}
	else if (DisplayKW == 2)
	{
			sStart = GregToJul(sJahr,sMonat,1,Stunden,Minuten,Sekunden)[3]-1;
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (sStart == 0)
				{
					sStart = 7;
				}
				sStart;
			}
			else
			{
				sStart++;
			}
	}
	else if (DisplayKW == 3)
	{
		var jd = islamic_to_jd(sJahr,sMonat,1);
		var fdisl = jd_to_gregorian(jd);

		sStart = GregToIsl(fdisl[0],fdisl[1],fdisl[2],Stunden,Minuten,Sekunden)[3];
		sStart++;
	}

	return sStart;
}

function erstelleZelle(z, Inhalt, sJahr, sMonat, zJahr, zMonat, zTag, KWcell)
{
	var tmpSun = "";
	var tmpKW = "";
	var tmpInh = "";
	var tmpAkt = 0;
	var tmpBtn, tmpBtnA;

	if ((DisplayKW != 2) && (DisplayKW != 3))
	{
		if (System.Gadget.Settings.read("kwshowselect") == 1)
		{
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (z == 7)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
			else
			{
				if (z == 1)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
		}
		else if (System.Gadget.Settings.read("kwshowselect") == 2)
		{
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (z == 6)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
			else
			{
				if (z == 0)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
		}
		else
		{
			if (System.Gadget.Settings.read("firstwdayselect") == 1)
			{
				if (z == 7)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
			else
			{
				if (z == 1)
				{
					tmpSun = "sun";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
				else
				{
					tmpSun = "";
					tmpBtn = CalBtn;
					tmpBtnA = CalBtnA;
				}
			}
		}
	}
	else
	{
		if (System.Gadget.Settings.read("firstwdayselect") == 1)
		{
			if (z == 7)
			{
				tmpSun = "sun";
				tmpBtn = CalBtn;
				tmpBtnA = CalBtnA;
			}
			else
			{
				tmpSun = "";
				tmpBtn = CalBtn;
				tmpBtnA = CalBtnA;
			}
		}
		else
		{
			if (z == 1)
			{
				tmpSun = "sun";
				tmpBtn = CalBtn;
				tmpBtnA = CalBtnA;
			}
			else
			{
				tmpSun = "";
				tmpBtn = CalBtn;
				tmpBtnA = CalBtnA;
			}
		}
	}

	if (Inhalt > 0)
	{
		tmpInh = Inhalt;
	}
	else
	{
		tmpInh = "&#160;";
	}

	if (KWcell)
	{
		tmpAkt = "0";
		tmpSun = "";
		tmpKW = "kw";
		tmpBtn = "";
		tmpBtnA = "";
	}
	else
	{
		if (DisplayKW == 3)
		{
//			zTag--;
			if ((sJahr == zJahr) && (sMonat == zMonat) && (Inhalt == zTag))
			{
				tmpAkt = "1";
			}
			else
			{
				tmpAkt = "0";
			}
		}
		else
		{
			if ((sJahr == zJahr) && (sMonat == zMonat) && (Inhalt == zTag))
			{
				tmpAkt = "1";
			}
			else
			{
				tmpAkt = "0";
			}
		}
	}


	var tmpzelle =  SchreibeZelle(tmpInh,tmpAkt,tmpBtn,tmpBtnA,tmpSun,tmpKW);
	return tmpzelle;

}

function SchreibeKopf(Monatskopf,CalBtn,CalBtnA)
{
	var tmpj, tmpm, tmpmprev, tmpmnext;
	var avCarr = System.Gadget.Settings.read("aktvisCal").split("|");
	tmpj = parseInt(avCarr[0]);
	tmpm = parseInt(avCarr[1]);
	if (tmpm == 1)
	{
		tmpmprev = 12;
		tmpmnext = tmpm+1;
	}
	else if (tmpm == 12)
	{
		tmpmprev = tmpm-1;
		tmpmnext = 1;
	}
	else
	{
		tmpmprev = tmpm-1;
		tmpmnext = tmpm+1;
	}

	var newCal = "";
	newCal += "<tr>";
	newCal += "<td style=";
	newCal += "\"background-image:url(";
	newCal += "/img/Themes/cal-left-x2.gif";
	newCal += ")\"";
	newCal += " onclick=\"buildcalendar(";
	newCal += (tmpj-1) + "," + tmpm;
	newCal += ")\" onMouseOver=\"showWMTT('d21')\" onMouseOut=\"hideWMTT()\">";
	newCal += "</td>";
	newCal += "<td style=";
	newCal += "\"background-image:url(";
	newCal += "/img/Themes/cal-left.gif";
	newCal += ")\"";
	newCal += " onclick=\"buildcalendar(";
	if (tmpm == 1)
	{
		newCal += (tmpj-1) + "," + tmpmprev;
	}
	else
	{
		newCal += tmpj + "," + tmpmprev;
	}
	newCal += ")\" onMouseOver=\"showWMTT('d22')\" onMouseOut=\"hideWMTT()\">";
	newCal += "</td>";
	newCal += "<td colspan=\"4\" align=\"center\" valign=\"middle\">";
	if (DisplayKW == 3) // Islamic
	{
		newCal += "<div id=\"calhead\" class=\"fontsmall\" onclick=\"buildcalendar(";
		newCal += Jahr + "," + Monat;
		newCal += ")\" onMouseOver=\"showWMTT('d23')\" onMouseOut=\"hideWMTT()\">";
		newCal += Monatskopf;
		newCal += "</div>";
	}
	else
	{
		newCal += "<div id=\"calhead\" class=\"fontnormal\" onclick=\"buildcalendar(";
		newCal += Jahr + "," + Monat;
		newCal += ")\" onMouseOver=\"showWMTT('d23')\" onMouseOut=\"hideWMTT()\">";
		newCal += Monatskopf;
		newCal += "</div>";
	}
	newCal += "</td>";
	newCal += "<td style=";
	newCal += "\"background-image:url(";
	newCal += "/img/Themes/cal-right.gif";
	newCal += ")\"";
	newCal += " onclick=\"buildcalendar(";
	if (tmpm == 12)
	{
		newCal += (tmpj+1) + "," + tmpmnext;
	}
	else
	{
		newCal += tmpj + "," + tmpmnext;
	}
	newCal += ")\" onMouseOver=\"showWMTT('d24')\" onMouseOut=\"hideWMTT()\">";
	newCal += "</td>";
	newCal += "<td style=";
	newCal += "\"background-image:url(";
	newCal += "/img/Themes/cal-right-x2.gif";
	newCal += ")\"";
	newCal += " onclick=\"buildcalendar(";
	newCal += (tmpj+1) + "," + tmpm;
	newCal += ")\" onMouseOver=\"showWMTT('d25')\" onMouseOut=\"hideWMTT()\">";
	newCal += "</td>";
	newCal += "</tr><tr>";
	if ((DisplayKW != 2) && (DisplayKW != 3))
	{
		if (System.Gadget.Settings.read("kwshowselect") == 1)
		{
			newCal += "<td width=\"15\" height=\"15\" align=\"left\" valign=\"middle\">";
			newCal += "<font color=\"" + gadgetcolournormal + "\">";
			newCal += "W";
			newCal += "</font>";
			newCal += "</td>";
		}
		else if (System.Gadget.Settings.read("kwshowselect") == 0)
		{
			newCal += "<td width=\"15\" height=\"15\" align=\"left\" valign=\"middle\">&#160;</td>";
		}
	}
	else
	{
		newCal += "<td width=\"15\" height=\"15\" align=\"left\" valign=\"middle\">&#160;</td>";
	}

	for(var i=0;i<=6;i++)
	{
		if (System.Gadget.Settings.read("firstwdayselect") == 1)
		{
			if (i == 6)
			{
				newCal += SchreibeZelle(calDays[0],"0",CalBtn,CalBtnA,"sun","");
			}
			else
			{
				newCal += SchreibeZelle(calDays[i+1],"0",CalBtn,CalBtnA,"","");
			}
		}
		else
		{
			if (i == 0)
			{
				newCal += SchreibeZelle(calDays[i],"0",CalBtn,CalBtnA,"sun","");
			}
			else
			{
				newCal += SchreibeZelle(calDays[i],"0",CalBtn,CalBtnA,"","");
			}
		}
	}
	if ((System.Gadget.Settings.read("kwshowselect") == 2) && ((DisplayKW != 2) || (DisplayKW != 3)))
	{
		newCal += "<td width=\"15\" height=\"15\" align=\"right\" valign=\"middle\">";
		newCal += "<font color=\"" + gadgetcolournormal + "\">";
		newCal += "W";
		newCal += "</font>";
		newCal += "</td>";
	}
	newCal += "</tr>";
	return newCal;
}

function SchreibeZelle(Inhalt,akt,CalBtn,CalBtnA,sunday,kw)
{
	var newCal = "";
	newCal += "<td width=\"15\" height\"15\"";
	newCal += " style=\"";
	newCal += "background-image:url(";

	if (akt == 1)
	{
		newCal += CalBtnA;
		if (sunday)
		{
			newCal += "); background-color:" + gadgetcolourlabel + "; cursor: pointer;\"";
		}
		else
		{
			newCal += "); background-color:" + gadgetcolourcritical + "; cursor: pointer;\"";
		}
	}
	else
	{
		newCal += CalBtn;
		newCal += ")\"";
	}

	if (kw)
	{
		if (System.Gadget.Settings.read("kwshowselect") == 1)
		{
			newCal += " align=\"left\"";
		}
		if (System.Gadget.Settings.read("kwshowselect") == 2)
		{
			newCal += " align=\"right\"";
		}
	}
	else
	{
		newCal += " align=\"center\"";
	}
	newCal += " valign=\"middle\"";
	if (akt == 1)
	{
		newCal += " onclick=\"LaunchApplet('cal')\"";
		newCal += " onMouseOver=\"showWMTT('d29')\"";
		newCal += " onMouseOut=\"hideWMTT()\"";
	}
	newCal += ">";
	newCal += "<b>";

	if (sunday)
	{
		newCal += "<font color=\"" + gadgetcolourcritical + "\">";
		newCal += Inhalt;
		newCal += "</font>";
	}
	else if (kw)
	{
		newCal += "<font color=\"" + gadgetcolournormal + "\">";
		newCal += Inhalt;
		newCal += "</font>";
	}
	else
	{
		newCal += Inhalt;
	}

	newCal += "</b></td>";
	return newCal;
}

function KalenderWocheISO(j,m,t)
{
	var a = Math.floor((14-(m))/12);
	var y = j+4800-a;
	var mo = (m)+(12*a)-3;
	var jd = t + Math.floor(((153*mo)+2)/5) +
			(365*y) + Math.floor(y/4) - Math.floor(y/100) +
			Math.floor(y/400) - 32045;

	var d4 = (jd+31741-(jd%7))%146097%36524%1461;
	var L = Math.floor(d4/1460);
	var d1 = ((d4-L)%365)+L;
	NumberOfWeek = Math.floor(d1/7) + 1;
	return NumberOfWeek;
}

function KalenderWocheUSA(j,m,t)
{
	var alleTage = 0;
	var Tage = new Array(12);
	Tage[0] = 31;
	Tage[1] = 28;
	var x = leap_gregorian(j);
	if(x)
	{
		Tage[1] = 29;
	}
	Tage[2] = 31;
	Tage[3] = 30;
	Tage[4] = 31;
	Tage[5] = 30;
	Tage[6] = 31;
	Tage[7] = 31;
	Tage[8] = 30;
	Tage[9] = 31;
	Tage[10] = 30;
	Tage[11] = 31;

	var d, Wochentag;
	var i = 0;
	var i2 = 0;
	var KW = 1;
	m--;

	for (i = 0; i <= m; i++)
	{
		if (m == i)
		{
			for (i2 = 1; i2 <= t; i2++)
			{
				d = new Date(j,m,i2);
				Wochentag = d.getDay();
				if (Wochentag == 0)
				{
					if (! ((m==0) && (i2==1)))
					{
						KW++;
					}
				}
			}
		}
		else
		{
			for(i2 = 1; i2 <= Tage[i]; i2++)
			{
				d = new Date(j,i,i2);
				Wochentag = d.getDay();
				if (Wochentag == 0)
				{
					if (! ((m==0) && (i2==1)))
					{
						KW++;
					}
				}
			}
		}
	}
	return KW;
}

//===================================================
// Following functions I've borrowed and modified
// from John Walker's script.
//===================================================
/*
       JavaScript functions for the Fourmilab Calendar Converter

                  by John Walker  --  September, MIM
              http://www.fourmilab.ch/documents/calendar/

                This program is in the public domain.
*/
//==================================================
function GregToJul(year,mon,mday,hour,min,sec)
{
	var weekday;
	var j = gregorian_to_jd(year, mon, mday) +
           (Math.floor(sec + 60 * (min + 60 * hour) + 0.5) / 86400.0);

	var julcal = jd_to_julian(j);
	weekday = jwday(j);

	return new Array(julcal[0],julcal[1],julcal[2],weekday);
}

function GregToIsl(year,mon,mday,hour,min,sec)
{
	var weekday;
	var j = gregorian_to_jd(year, mon, mday) +
           (Math.floor(sec + 60 * (min + 60 * hour) + 0.5) / 86400.0);

	var islcal = jd_to_islamic(j);
	weekday = jwday(j);

	return new Array(islcal[0],islcal[1],islcal[2],weekday);
}

/*  MOD  --  Modulus function which works for non-integers.  */

function mod(a, b)
{
	return a - (b * Math.floor(a / b));
}

//  JWDAY  --  Calculate day of week from Julian day

function jwday(j)
{
	return mod(Math.floor((j + 1.5)), 7);
}

//  ISLAMIC_TO_JD  --  Determine Julian day from Islamic date

var ISLAMIC_EPOCH = 1948439.5;
var ISLAMIC_WEEKDAYS = new Array("al-'ahad", "al-'ithnayn",
                                 "ath-thalatha'", "al-'arb`a'",
                                 "al-khamis", "al-jum`a", "as-sabt");
function islamic_to_jd(year, month, day)
{
    return (day +
            Math.ceil(29.5 * (month - 1)) +
            (year - 1) * 354 +
            Math.floor((3 + (11 * year)) / 30) +
            ISLAMIC_EPOCH) - 1;
}


//  JD_TO_ISLAMIC  --  Calculate Islamic date from Julian day

function jd_to_islamic(jd)
{
    var year, month, day;

    jd = Math.floor(jd) + 0.5;
    year = Math.floor(((30 * (jd - ISLAMIC_EPOCH)) + 10646) / 10631);
    month = Math.min(12,
                Math.ceil((jd - (29 + islamic_to_jd(year, 1, 1))) / 29.5) + 1);
    day = (jd - islamic_to_jd(year, month, 1)) + 1;
    return new Array(year, month, day);
}

//  GREGORIAN_TO_JD  --  Determine Julian day number from Gregorian calendar date

var GREGORIAN_EPOCH = 1721425.5;

function gregorian_to_jd(year, month, day)
{
    return (GREGORIAN_EPOCH - 1) +
           (365 * (year - 1)) +
           Math.floor((year - 1) / 4) +
           (-Math.floor((year - 1) / 100)) +
           Math.floor((year - 1) / 400) +
           Math.floor((((367 * month) - 362) / 12) +
           ((month <= 2) ? 0 :
                               (leap_gregorian(year) ? -1 : -2)
           ) +
           day);
}

//  LEAP_GREGORIAN  --  Is a given year in the Gregorian calendar a leap year ?

function leap_gregorian(year)
{
    return ((year % 4) == 0) &&
            (!(((year % 100) == 0) && ((year % 400) != 0)));
}

//  LEAP_JULIAN  --  Is a given year in the Julian calendar a leap year ?

function leap_julian(year)
{
    return mod(year, 4) == ((year > 0) ? 0 : 3);
//	return (year % 4) == ((year > 0) ? 0 : 3);
}

//  LEAP_ISLAMIC  --  Is a given year a leap year in the Islamic calendar ?

function leap_islamic(year)
{
    return (((year * 11) + 14) % 30) < 11;
}

//  JD_TO_JULIAN  --  Calculate Julian calendar date from Julian day

function jd_to_julian(td)
{
    var z, a, alpha, b, c, d, e, year, month, day;

    td += 0.5;
    z = Math.floor(td);

    a = z;
    b = a + 1524;
    c = Math.floor((b - 122.1) / 365.25);
    d = Math.floor(365.25 * c);
    e = Math.floor((b - d) / 30.6001);

    month = Math.floor((e < 14) ? (e - 1) : (e - 13));
    year = Math.floor((month > 2) ? (c - 4716) : (c - 4715));
    day = b - d - Math.floor(30.6001 * e);

    /*  If year is less than 1, subtract one to convert from
        a zero based date system to the common era system in
        which the year -1 (1 B.C.E) is followed by year 1 (1 C.E.).  */

    if (year < 1) {
        year--;
    }

    return new Array(year, month, day);
}

//  JD_TO_GREGORIAN  --  Calculate Gregorian calendar date from Julian day

function jd_to_gregorian(jd) {
    var wjd, depoch, quadricent, dqc, cent, dcent, quad, dquad,
        yindex, dyindex, year, yearday, leapadj;

    wjd = Math.floor(jd - 0.5) + 0.5;
    depoch = wjd - GREGORIAN_EPOCH;
    quadricent = Math.floor(depoch / 146097);
    dqc = mod(depoch, 146097);
    cent = Math.floor(dqc / 36524);
    dcent = mod(dqc, 36524);
    quad = Math.floor(dcent / 1461);
    dquad = mod(dcent, 1461);
    yindex = Math.floor(dquad / 365);
    year = (quadricent * 400) + (cent * 100) + (quad * 4) + yindex;
    if (!((cent == 4) || (yindex == 4))) {
        year++;
    }
    yearday = wjd - gregorian_to_jd(year, 1, 1);
    leapadj = ((wjd < gregorian_to_jd(year, 3, 1)) ? 0
                                                  :
                  (leap_gregorian(year) ? 1 : 2)
              );
    month = Math.floor((((yearday + leapadj) * 12) + 373) / 367);
    day = (wjd - gregorian_to_jd(year, month, 1)) + 1;

    return new Array(year, month, day);
}


